From fbf4958671bf4fa90463428a717fdd9a4d4ee2bc Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Wed, 17 Jul 2019 09:16:43 +0200
Subject: [PATCH] templates: add CSS classes to account management actions
 (#29765)

---
 templates/authentic2/accounts.html                        | 8 ++++----
 templates/authentic2/login_password_profile.html          | 4 ++--
 .../variants/bouches-du-rhone/authentic2/accounts.html    | 2 +-
 .../variants/haute-garonne-cd31/authentic2/accounts.html  | 2 +-
 templates/variants/lille/authentic2/accounts.html         | 2 +-
 .../variants/nancy-en-direct/authentic2/accounts.html     | 2 +-
 templates/variants/quimper/authentic2/accounts.html       | 2 +-
 7 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/templates/authentic2/accounts.html b/templates/authentic2/accounts.html
index d069e74d..66f2deab 100644
--- a/templates/authentic2/accounts.html
+++ b/templates/authentic2/accounts.html
@@ -42,16 +42,16 @@
       {% block account-management-top-actions %}
       {% endblock %}
       {% if allow_email_change %}
-      <li><a href="{% url 'email-change' %}">Modifier le courriel associé</a></li>
+      <li class="email-change"><a href="{% url 'email-change' %}">Modifier le courriel associé</a></li>
       {% endif %}
       {{ frontends_block_by_id.password.content|safe }}
       {% if profile_edit_url %}
-      <li><a href="{{ profile_edit_url }}">Éditer les données du compte</a></li>
+      <li class="profile-edit"><a href="{{ profile_edit_url }}">Éditer les données du compte</a></li>
       {% elif allow_profile_edit %}
-      <li><a href="{% url 'profile_edit' %}">Éditer les données du compte</a></li>
+      <li class="profile-edit"><a href="{% url 'profile_edit' %}">Éditer les données du compte</a></li>
       {% endif %}
       {% if allow_account_deletion %}
-      <li><a href="{% url 'delete_account' %}">Supprimer le compte</a></li>
+      <li class="account-delete"><a href="{% url 'delete_account' %}">Supprimer le compte</a></li>
       {% endif %}
       {% block account-management-bottom-actions %}
       {% endblock %}
diff --git a/templates/authentic2/login_password_profile.html b/templates/authentic2/login_password_profile.html
index 9463a640..b41e5f6b 100644
--- a/templates/authentic2/login_password_profile.html
+++ b/templates/authentic2/login_password_profile.html
@@ -1,7 +1,7 @@
 {% if can_change_password %}
   {% if has_usable_password %}
-    <li><a href="{% url 'password_change' %}">Modifier le mot de passe</a></li>
+    <li class="password-change"><a href="{% url 'password_change' %}">Modifier le mot de passe</a></li>
   {% else %}
-    <li><a href="{% url 'password_change' %}">Définir un mot de passe</a></li>
+    <li class="password-set"><a href="{% url 'password_change' %}">Définir un mot de passe</a></li>
   {% endif %}
 {% endif %}
diff --git a/templates/variants/bouches-du-rhone/authentic2/accounts.html b/templates/variants/bouches-du-rhone/authentic2/accounts.html
index 6e62b4f1..889c25b5 100644
--- a/templates/variants/bouches-du-rhone/authentic2/accounts.html
+++ b/templates/variants/bouches-du-rhone/authentic2/accounts.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
-<li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
+<li class="account-logout"><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
 {% endblock %}
diff --git a/templates/variants/haute-garonne-cd31/authentic2/accounts.html b/templates/variants/haute-garonne-cd31/authentic2/accounts.html
index 6e62b4f1..889c25b5 100644
--- a/templates/variants/haute-garonne-cd31/authentic2/accounts.html
+++ b/templates/variants/haute-garonne-cd31/authentic2/accounts.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
-<li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
+<li class="account-logout"><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
 {% endblock %}
diff --git a/templates/variants/lille/authentic2/accounts.html b/templates/variants/lille/authentic2/accounts.html
index 6e62b4f1..889c25b5 100644
--- a/templates/variants/lille/authentic2/accounts.html
+++ b/templates/variants/lille/authentic2/accounts.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
-<li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
+<li class="account-logout"><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
 {% endblock %}
diff --git a/templates/variants/nancy-en-direct/authentic2/accounts.html b/templates/variants/nancy-en-direct/authentic2/accounts.html
index 6e62b4f1..889c25b5 100644
--- a/templates/variants/nancy-en-direct/authentic2/accounts.html
+++ b/templates/variants/nancy-en-direct/authentic2/accounts.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
-<li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
+<li class="account-logout"><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
 {% endblock %}
diff --git a/templates/variants/quimper/authentic2/accounts.html b/templates/variants/quimper/authentic2/accounts.html
index 6e62b4f1..889c25b5 100644
--- a/templates/variants/quimper/authentic2/accounts.html
+++ b/templates/variants/quimper/authentic2/accounts.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/accounts.html" %}
 
 {% block account-management-bottom-actions %}
-<li><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
+<li class="account-logout"><a href="{% url 'auth_logout' %}">Déconnecter</a></li>
 {% endblock %}
-- 
2.22.0